package com.kuaishou.common.netty;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;

/**
 *
 * +----------------------------------+
 * |version(8bit)|magic number(24bit) |
 * +----------------------------------+
 * |    header reserved(64bit)        |
 * +----------------------------------+
 * |      body length (32bit)         |
 * +----------------------------------+
 * |      body (protobuf)             |
 * +----------------------------------+
 *
 * @author Li Weibo  //I believe in Spring Brother.
 *
 */
@Sharable
public abstract class AbstractSocketMessageEncoder<T> extends MessageToByteEncoder<T> {

    @Override
    protected void encode(ChannelHandlerContext ctx, T msg, ByteBuf out)
            throws Exception {
        SocketMessageEncoderUtil.write(toByteArray(msg), out);
    }

    public abstract byte[] toByteArray(T msg);

}
