package com.kuaishou.common.netty;


/**
 * @author Li Weibo  //I believe in Spring Brother.
 *
 */
public class Constants {

    /**
     * 协议版本
     */
    public static final byte PROTOCOL_VERSION = 1;

    /**
     * magic number
     */
    public static final byte[] MAGIC_BYTES = new byte[] { 0x1A, 0x2B, 0x3C };

    /**
     * header保留数据的长度
     */
    public static final int HEADER_RESERVED_BYTES = 8;

    /**
     * header长度
     */
    public static final int HEADER_LENGTH = 1 //version
            + MAGIC_BYTES.length //
            + HEADER_RESERVED_BYTES //
            + 4 //body length
            ;

    /**
     * body最大长度
     */
    public static final int MAX_BODY_LENGTH = 1024 * 128;

}
