package com.kuaishou.common.netty;

import io.netty.buffer.ByteBuf;

/**
 * @author Li Weibo  //I believe in Spring Brother.
 *
 */
public class SocketMessageEncoderUtil {

    /**
     * 把给定的二进制message body加上文件头一起写入到指定的{@link ByteBuf}中去
     *
     * @param msgBody 二进制的message body
     * @param out 要写入的buffer
     */
    public static void write(byte[] msgBody, ByteBuf out) {
        out.writeByte(Constants.PROTOCOL_VERSION);
        out.writeBytes(Constants.MAGIC_BYTES);
        out.writeBytes(new byte[Constants.HEADER_RESERVED_BYTES]); //header reserved(64bit)
        out.writeInt(msgBody.length); //write length
        out.writeBytes(msgBody); //write body
    }

}
